# Class BimTypeObject

Type-level definition (e.g. `IfcWallType`, `IfcDoorType`) with its own property and quantity sets. Products reference their type via ModelProduct.type.

#### Implements

- ModelEntityType

##### Index

### Constructors

constructor

### Properties

attributes
description?
globalId
id
ifcClass
name?
propertySets
quantitySets
tag?

### Accessors

className
data

## Constructors

### constructor

- new BimTypeObject(
  id: number,
  globalId: string,
  ifcClass: string,
  tag?: string,
  name?: string,
  description?: string,
  attributes?: DeepImmutable<BimIndexableIfcObject>,
  ): BimTypeObject

  #### Parameters

  - id: number
  - globalId: string
  - ifcClass: string
  - `Optional` tag: string
  - `Optional` name: string
  - `Optional` description: string
  - attributes: DeepImmutable<BimIndexableIfcObject> = {}

    Contains type specific attributes (e.g operationMode) Readonly

  #### Returns BimTypeObject

## Properties

### `Readonly` attributes

attributes: DeepImmutable<BimIndexableIfcObject> = {}

Contains type specific attributes (e.g operationMode) Readonly

### `Optional` `Readonly` description

description?: string

### `Readonly` globalId

globalId: string

Implementation of ModelEntityType.globalId

### `Readonly` id

id: number

### `Readonly` ifcClass

ifcClass: string

### `Optional` `Readonly` name

name?: string

Implementation of ModelEntityType.name

### `Readonly` propertySets

propertySets: Record<string, T8PropertySet<T8Unit>> = emptyRecord

Implementation of ModelEntityType.propertySets

### `Readonly` quantitySets

quantitySets: Record<string, T8QuantitySet<T8Unit>> = emptyRecord

Implementation of ModelEntityType.quantitySets

### `Optional` `Readonly` tag

tag?: string

## Accessors

### className

- get className(): string

  Full IFC type class name (e.g. `'IfcWallType'`).

  #### Returns string

  Implementation of ModelEntityType.className

### data

- get data(): Record<string, string | number | boolean>

  Type-level scalar data values.

  #### Returns Record<string, string | number | boolean>

  Implementation of ModelEntityType.data